/* libnih
 *
 * com.netsplit.Nih.Test_object.c - Auto-generated d-bus bindings
 *
 * Copyright © 2008 Scott James Remnant <scott@netsplit.com>.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */


#include <dbus/dbus.h>

#include <errno.h>
#include <limits.h>

#include <nih/macros.h>
#include <nih/alloc.h>
#include <nih/string.h>
#include <nih/logging.h>
#include <nih/error.h>
#include <nih/errors.h>
#include <nih/dbus.h>

#include "com.netsplit.Nih.Test_object.h"


/* Prototypes for handler functions */
extern int my_test_method        (void *data, NihDBusMessage *message, const char *input, int32_t flags, char **output);
extern int my_test_async_method  (void *data, NihDBusMessage *message, const char *input, int32_t flags);
extern int my_byte_to_str        (void *data, NihDBusMessage *message, uint8_t input, char **output);
extern int my_str_to_byte        (void *data, NihDBusMessage *message, const char *input, uint8_t *output);
extern int my_boolean_to_str     (void *data, NihDBusMessage *message, int input, char **output);
extern int my_str_to_boolean     (void *data, NihDBusMessage *message, const char *input, int *output);
extern int my_int16_to_str       (void *data, NihDBusMessage *message, int16_t input, char **output);
extern int my_str_to_int16       (void *data, NihDBusMessage *message, const char *input, int16_t *output);
extern int my_uint16_to_str      (void *data, NihDBusMessage *message, uint16_t input, char **output);
extern int my_str_to_uint16      (void *data, NihDBusMessage *message, const char *input, uint16_t *output);
extern int my_int32_to_str       (void *data, NihDBusMessage *message, int32_t input, char **output);
extern int my_str_to_int32       (void *data, NihDBusMessage *message, const char *input, int32_t *output);
extern int my_uint32_to_str      (void *data, NihDBusMessage *message, uint32_t input, char **output);
extern int my_str_to_uint32      (void *data, NihDBusMessage *message, const char *input, uint32_t *output);
extern int my_int64_to_str       (void *data, NihDBusMessage *message, int64_t input, char **output);
extern int my_str_to_int64       (void *data, NihDBusMessage *message, const char *input, int64_t *output);
extern int my_uint64_to_str      (void *data, NihDBusMessage *message, uint64_t input, char **output);
extern int my_str_to_uint64      (void *data, NihDBusMessage *message, const char *input, uint64_t *output);
extern int my_double_to_str      (void *data, NihDBusMessage *message, double input, char **output);
extern int my_str_to_double      (void *data, NihDBusMessage *message, const char *input, double *output);
extern int my_object_path_to_str (void *data, NihDBusMessage *message, const char *input, char **output);
extern int my_str_to_object_path (void *data, NihDBusMessage *message, const char *input, char **output);
extern int my_signature_to_str   (void *data, NihDBusMessage *message, const char *input, char **output);
extern int my_str_to_signature   (void *data, NihDBusMessage *message, const char *input, char **output);
extern int my_int32_array_to_str (void *data, NihDBusMessage *message, const int32_t *input, size_t input_len, char **output);
extern int my_str_to_int32_array (void *data, NihDBusMessage *message, const char *input, int32_t **output, size_t *output_len);
extern int my_str_array_to_str   (void *data, NihDBusMessage *message, char * const *input, char **output);
extern int my_str_to_str_array   (void *data, NihDBusMessage *message, const char *input, char ***output);
extern int my_emit_signal        (void *data, NihDBusMessage *message, int32_t signum);


/* Prototypes for static functions */
static DBusHandlerResult com_netsplit_Nih_Test_TestMethod_marshal      (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_TestAsyncMethod_marshal (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_ByteToStr_marshal       (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToByte_marshal       (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_BooleanToStr_marshal    (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToBoolean_marshal    (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_Int16ToStr_marshal      (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToInt16_marshal      (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_UInt16ToStr_marshal     (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToUInt16_marshal     (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_Int32ToStr_marshal      (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToInt32_marshal      (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_UInt32ToStr_marshal     (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToUInt32_marshal     (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_Int64ToStr_marshal      (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToInt64_marshal      (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_UInt64ToStr_marshal     (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToUInt64_marshal     (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_DoubleToStr_marshal     (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToDouble_marshal     (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_ObjectPathToStr_marshal (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToObjectPath_marshal (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_SignatureToStr_marshal  (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToSignature_marshal  (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_Int32ArrayToStr_marshal (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToInt32Array_marshal (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrArrayToStr_marshal   (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Test_StrToStrArray_marshal   (NihDBusObject *object, NihDBusMessage *message);
static DBusHandlerResult com_netsplit_Nih_Glue_EmitSignal_marshal      (NihDBusObject *object, NihDBusMessage *message);


static const NihDBusArg com_netsplit_Nih_Test_TestMethod_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "flags",  "i", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_TestAsyncMethod_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "flags",  "i", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_ByteToStr_args[] = {
	{ "input",  "y", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToByte_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "y", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_BooleanToStr_args[] = {
	{ "input",  "b", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToBoolean_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "b", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_Int16ToStr_args[] = {
	{ "input",  "n", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToInt16_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "n", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_UInt16ToStr_args[] = {
	{ "input",  "q", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToUInt16_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "q", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_Int32ToStr_args[] = {
	{ "input",  "i", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToInt32_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "i", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_UInt32ToStr_args[] = {
	{ "input",  "u", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToUInt32_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "u", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_Int64ToStr_args[] = {
	{ "input",  "x", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToInt64_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "x", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_UInt64ToStr_args[] = {
	{ "input",  "t", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToUInt64_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "t", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_DoubleToStr_args[] = {
	{ "input",  "d", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToDouble_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "d", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_ObjectPathToStr_args[] = {
	{ "input",  "o", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToObjectPath_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "o", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_SignatureToStr_args[] = {
	{ "input",  "g", NIH_DBUS_ARG_IN  },
	{ "output", "s", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToSignature_args[] = {
	{ "input",  "s", NIH_DBUS_ARG_IN  },
	{ "output", "g", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_Int32ArrayToStr_args[] = {
	{ "input",  "ai", NIH_DBUS_ARG_IN  },
	{ "output", "s",  NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToInt32Array_args[] = {
	{ "input",  "s",  NIH_DBUS_ARG_IN  },
	{ "output", "ai", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrArrayToStr_args[] = {
	{ "input",  "as", NIH_DBUS_ARG_IN  },
	{ "output", "s",  NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_StrToStrArray_args[] = {
	{ "input",  "s",  NIH_DBUS_ARG_IN  },
	{ "output", "as", NIH_DBUS_ARG_OUT },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_TestSignal_args[] = {
	{ "text",  "s", NIH_DBUS_ARG_IN },
	{ "flags", "i", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitByte_args[] = {
	{ "data", "y", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitBoolean_args[] = {
	{ "data", "b", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitInt16_args[] = {
	{ "data", "n", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitUInt16_args[] = {
	{ "data", "q", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitInt32_args[] = {
	{ "data", "i", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitUInt32_args[] = {
	{ "data", "u", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitInt64_args[] = {
	{ "data", "x", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitUInt64_args[] = {
	{ "data", "t", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitDouble_args[] = {
	{ "data", "d", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitString_args[] = {
	{ "data", "s", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitObjectPath_args[] = {
	{ "data", "o", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitSignature_args[] = {
	{ "data", "g", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitInt32Array_args[] = {
	{ "data", "ai", NIH_DBUS_ARG_IN },
	{ NULL }
};

static const NihDBusArg com_netsplit_Nih_Test_EmitStrArray_args[] = {
	{ "data", "as", NIH_DBUS_ARG_IN },
	{ NULL }
};

const NihDBusMethod com_netsplit_Nih_Test_methods[] = {
	{ "TestMethod",      com_netsplit_Nih_Test_TestMethod_marshal,      com_netsplit_Nih_Test_TestMethod_args      },
	{ "TestAsyncMethod", com_netsplit_Nih_Test_TestAsyncMethod_marshal, com_netsplit_Nih_Test_TestAsyncMethod_args },
	{ "ByteToStr",       com_netsplit_Nih_Test_ByteToStr_marshal,       com_netsplit_Nih_Test_ByteToStr_args       },
	{ "StrToByte",       com_netsplit_Nih_Test_StrToByte_marshal,       com_netsplit_Nih_Test_StrToByte_args       },
	{ "BooleanToStr",    com_netsplit_Nih_Test_BooleanToStr_marshal,    com_netsplit_Nih_Test_BooleanToStr_args    },
	{ "StrToBoolean",    com_netsplit_Nih_Test_StrToBoolean_marshal,    com_netsplit_Nih_Test_StrToBoolean_args    },
	{ "Int16ToStr",      com_netsplit_Nih_Test_Int16ToStr_marshal,      com_netsplit_Nih_Test_Int16ToStr_args      },
	{ "StrToInt16",      com_netsplit_Nih_Test_StrToInt16_marshal,      com_netsplit_Nih_Test_StrToInt16_args      },
	{ "UInt16ToStr",     com_netsplit_Nih_Test_UInt16ToStr_marshal,     com_netsplit_Nih_Test_UInt16ToStr_args     },
	{ "StrToUInt16",     com_netsplit_Nih_Test_StrToUInt16_marshal,     com_netsplit_Nih_Test_StrToUInt16_args     },
	{ "Int32ToStr",      com_netsplit_Nih_Test_Int32ToStr_marshal,      com_netsplit_Nih_Test_Int32ToStr_args      },
	{ "StrToInt32",      com_netsplit_Nih_Test_StrToInt32_marshal,      com_netsplit_Nih_Test_StrToInt32_args      },
	{ "UInt32ToStr",     com_netsplit_Nih_Test_UInt32ToStr_marshal,     com_netsplit_Nih_Test_UInt32ToStr_args     },
	{ "StrToUInt32",     com_netsplit_Nih_Test_StrToUInt32_marshal,     com_netsplit_Nih_Test_StrToUInt32_args     },
	{ "Int64ToStr",      com_netsplit_Nih_Test_Int64ToStr_marshal,      com_netsplit_Nih_Test_Int64ToStr_args      },
	{ "StrToInt64",      com_netsplit_Nih_Test_StrToInt64_marshal,      com_netsplit_Nih_Test_StrToInt64_args      },
	{ "UInt64ToStr",     com_netsplit_Nih_Test_UInt64ToStr_marshal,     com_netsplit_Nih_Test_UInt64ToStr_args     },
	{ "StrToUInt64",     com_netsplit_Nih_Test_StrToUInt64_marshal,     com_netsplit_Nih_Test_StrToUInt64_args     },
	{ "DoubleToStr",     com_netsplit_Nih_Test_DoubleToStr_marshal,     com_netsplit_Nih_Test_DoubleToStr_args     },
	{ "StrToDouble",     com_netsplit_Nih_Test_StrToDouble_marshal,     com_netsplit_Nih_Test_StrToDouble_args     },
	{ "ObjectPathToStr", com_netsplit_Nih_Test_ObjectPathToStr_marshal, com_netsplit_Nih_Test_ObjectPathToStr_args },
	{ "StrToObjectPath", com_netsplit_Nih_Test_StrToObjectPath_marshal, com_netsplit_Nih_Test_StrToObjectPath_args },
	{ "SignatureToStr",  com_netsplit_Nih_Test_SignatureToStr_marshal,  com_netsplit_Nih_Test_SignatureToStr_args  },
	{ "StrToSignature",  com_netsplit_Nih_Test_StrToSignature_marshal,  com_netsplit_Nih_Test_StrToSignature_args  },
	{ "Int32ArrayToStr", com_netsplit_Nih_Test_Int32ArrayToStr_marshal, com_netsplit_Nih_Test_Int32ArrayToStr_args },
	{ "StrToInt32Array", com_netsplit_Nih_Test_StrToInt32Array_marshal, com_netsplit_Nih_Test_StrToInt32Array_args },
	{ "StrArrayToStr",   com_netsplit_Nih_Test_StrArrayToStr_marshal,   com_netsplit_Nih_Test_StrArrayToStr_args   },
	{ "StrToStrArray",   com_netsplit_Nih_Test_StrToStrArray_marshal,   com_netsplit_Nih_Test_StrToStrArray_args   },
	{ NULL }
};

const NihDBusSignal com_netsplit_Nih_Test_signals[] = {
	{ "TestSignal",     com_netsplit_Nih_Test_TestSignal_args     },
	{ "EmitByte",       com_netsplit_Nih_Test_EmitByte_args       },
	{ "EmitBoolean",    com_netsplit_Nih_Test_EmitBoolean_args    },
	{ "EmitInt16",      com_netsplit_Nih_Test_EmitInt16_args      },
	{ "EmitUInt16",     com_netsplit_Nih_Test_EmitUInt16_args     },
	{ "EmitInt32",      com_netsplit_Nih_Test_EmitInt32_args      },
	{ "EmitUInt32",     com_netsplit_Nih_Test_EmitUInt32_args     },
	{ "EmitInt64",      com_netsplit_Nih_Test_EmitInt64_args      },
	{ "EmitUInt64",     com_netsplit_Nih_Test_EmitUInt64_args     },
	{ "EmitDouble",     com_netsplit_Nih_Test_EmitDouble_args     },
	{ "EmitString",     com_netsplit_Nih_Test_EmitString_args     },
	{ "EmitObjectPath", com_netsplit_Nih_Test_EmitObjectPath_args },
	{ "EmitSignature",  com_netsplit_Nih_Test_EmitSignature_args  },
	{ "EmitInt32Array", com_netsplit_Nih_Test_EmitInt32Array_args },
	{ "EmitStrArray",   com_netsplit_Nih_Test_EmitStrArray_args   },
	{ NULL }
};

const NihDBusInterface com_netsplit_Nih_Test = {
	"com.netsplit.Nih.Test",
	com_netsplit_Nih_Test_methods,
	com_netsplit_Nih_Test_signals,
	NULL
};

static const NihDBusArg com_netsplit_Nih_Glue_EmitSignal_args[] = {
	{ "signum", "i", NIH_DBUS_ARG_IN },
	{ NULL }
};

const NihDBusMethod com_netsplit_Nih_Glue_methods[] = {
	{ "EmitSignal", com_netsplit_Nih_Glue_EmitSignal_marshal, com_netsplit_Nih_Glue_EmitSignal_args },
	{ NULL }
};

const NihDBusSignal com_netsplit_Nih_Glue_signals[] = {
	{ NULL }
};

const NihDBusInterface com_netsplit_Nih_Glue = {
	"com.netsplit.Nih.Glue",
	com_netsplit_Nih_Glue_methods,
	com_netsplit_Nih_Glue_signals,
	NULL
};


static DBusHandlerResult
com_netsplit_Nih_Test_TestMethod_marshal (NihDBusObject  *object,
                                          NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	int32_t          flags;
	char            *input_value;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to TestMethod method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INT32) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to TestMethod method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &flags);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to TestMethod method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_test_method (object->data, message, input, flags, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_TestAsyncMethod_marshal (NihDBusObject  *object,
                                               NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	int32_t          flags;
	char            *input_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to TestAsyncMethod method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INT32) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to TestAsyncMethod method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &flags);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to TestAsyncMethod method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_test_async_method (object->data, message, input, flags) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	return DBUS_HANDLER_RESULT_NOT_YET_HANDLED;

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

int
my_test_async_method_reply (NihDBusMessage *message,
                            const char     *output)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	const char      *output_value;

	nih_assert (message != NULL);

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message)) {
		nih_free (message);
		return 0;
	}

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return -1;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return -1;
	}

	dbus_message_unref (reply);
	nih_free (message);

	return 0;
}

static DBusHandlerResult
com_netsplit_Nih_Test_ByteToStr_marshal (NihDBusObject  *object,
                                         NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	uint8_t          input;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_BYTE) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to ByteToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to ByteToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_byte_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToByte_marshal (NihDBusObject  *object,
                                         NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	uint8_t          output;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToByte method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToByte method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_byte (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_BYTE, &output)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_BooleanToStr_marshal (NihDBusObject  *object,
                                            NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	int              input;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_BOOLEAN) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to BooleanToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to BooleanToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_boolean_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToBoolean_marshal (NihDBusObject  *object,
                                            NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	int              output;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToBoolean method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToBoolean method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_boolean (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_BOOLEAN, &output)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_Int16ToStr_marshal (NihDBusObject  *object,
                                          NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	int16_t          input;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INT16) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Int16ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Int16ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_int16_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToInt16_marshal (NihDBusObject  *object,
                                          NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	int16_t          output;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToInt16 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToInt16 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_int16 (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT16, &output)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_UInt16ToStr_marshal (NihDBusObject  *object,
                                           NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	uint16_t         input;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_UINT16) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to UInt16ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to UInt16ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_uint16_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToUInt16_marshal (NihDBusObject  *object,
                                           NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	uint16_t         output;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToUInt16 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToUInt16 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_uint16 (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_UINT16, &output)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_Int32ToStr_marshal (NihDBusObject  *object,
                                          NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	int32_t          input;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INT32) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Int32ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Int32ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_int32_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToInt32_marshal (NihDBusObject  *object,
                                          NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	int32_t          output;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToInt32 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToInt32 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_int32 (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &output)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_UInt32ToStr_marshal (NihDBusObject  *object,
                                           NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	uint32_t         input;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_UINT32) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to UInt32ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to UInt32ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_uint32_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToUInt32_marshal (NihDBusObject  *object,
                                           NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	uint32_t         output;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToUInt32 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToUInt32 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_uint32 (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_UINT32, &output)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_Int64ToStr_marshal (NihDBusObject  *object,
                                          NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	int64_t          input;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INT64) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Int64ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Int64ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_int64_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToInt64_marshal (NihDBusObject  *object,
                                          NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	int64_t          output;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToInt64 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToInt64 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_int64 (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT64, &output)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_UInt64ToStr_marshal (NihDBusObject  *object,
                                           NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	uint64_t         input;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_UINT64) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to UInt64ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to UInt64ToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_uint64_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToUInt64_marshal (NihDBusObject  *object,
                                           NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	uint64_t         output;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToUInt64 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToUInt64 method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_uint64 (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_UINT64, &output)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_DoubleToStr_marshal (NihDBusObject  *object,
                                           NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	double           input;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_DOUBLE) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to DoubleToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to DoubleToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_double_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToDouble_marshal (NihDBusObject  *object,
                                           NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	double           output;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToDouble method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToDouble method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_double (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_DOUBLE, &output)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_ObjectPathToStr_marshal (NihDBusObject  *object,
                                               NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_OBJECT_PATH) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to ObjectPathToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to ObjectPathToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_object_path_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToObjectPath_marshal (NihDBusObject  *object,
                                               NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToObjectPath method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToObjectPath method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_object_path (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_SignatureToStr_marshal (NihDBusObject  *object,
                                              NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_SIGNATURE) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to SignatureToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to SignatureToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_signature_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToSignature_marshal (NihDBusObject  *object,
                                              NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToSignature method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToSignature method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_signature (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_SIGNATURE, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_Int32ArrayToStr_marshal (NihDBusObject  *object,
                                               NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	int32_t         *input;
	size_t           input_len;
	DBusMessageIter  input_iter;
	char            *output;
	char            *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_ARRAY) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Int32ArrayToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	if (dbus_message_iter_get_element_type (&iter) != DBUS_TYPE_INT32) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Int32ArrayToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_recurse (&iter, &input_iter);

	input = NULL;
	input_len = 0;

	while (dbus_message_iter_get_arg_type (&input_iter) != DBUS_TYPE_INVALID) {
		int32_t input_elem;

		if (dbus_message_iter_get_arg_type (&input_iter) != DBUS_TYPE_INT32) {
			reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
							_("Invalid arguments to Int32ArrayToStr method"));
			if (! reply) {
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			}

			goto send;

		}

		dbus_message_iter_get_basic (&input_iter, &input_elem);

		dbus_message_iter_next (&input_iter);

		input = nih_realloc (input, message, sizeof (int32_t) * ((input_len) + 1));
		if (! input) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		(input)[(input_len)++] = input_elem;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to Int32ArrayToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_int32_array_to_str (object->data, message, input, input_len, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToInt32Array_marshal (NihDBusObject  *object,
                                               NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	char            *input;
	char            *input_value;
	int32_t         *output;
	size_t           output_len;
	DBusMessageIter  output_iter;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToInt32Array method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToInt32Array method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_int32_array (object->data, message, input, &output, &output_len) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_open_container (&iter, DBUS_TYPE_ARRAY, "i", &output_iter)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	for (int32_t *output_p = output; output_p < output + output_len; output_p++) {
		int32_t output_elem;

		output_elem = *output_p;

		if (! dbus_message_iter_append_basic (&output_iter, DBUS_TYPE_INT32, &output_elem)) {
			dbus_message_unref (reply);
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}
	}

	if (! dbus_message_iter_close_container (&iter, &output_iter)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrArrayToStr_marshal (NihDBusObject  *object,
                                             NihDBusMessage *message)
{
	DBusMessageIter   iter;
	DBusMessage      *reply = NULL;
	char            **input;
	DBusMessageIter   input_iter;
	size_t            input_len;
	char             *output;
	char             *output_value;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_ARRAY) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrArrayToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	if (dbus_message_iter_get_element_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrArrayToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_recurse (&iter, &input_iter);

	input = NULL;
	input_len = 0;

	while (dbus_message_iter_get_arg_type (&input_iter) != DBUS_TYPE_INVALID) {
		char *input_elem;
		char *input_elem_value;

		if (dbus_message_iter_get_arg_type (&input_iter) != DBUS_TYPE_STRING) {
			reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
							_("Invalid arguments to StrArrayToStr method"));
			if (! reply) {
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			}

			goto send;

		}

		dbus_message_iter_get_basic (&input_iter, &input_elem_value);

		input_elem = nih_strdup (message, input_elem_value);
		if (! input_elem) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		dbus_message_iter_next (&input_iter);

		input = nih_realloc (input, message, sizeof (char *) * ((input_len) + 1));
		if (! input) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		(input)[(input_len)++] = input_elem;

	}

	dbus_message_iter_next (&iter);

	input = nih_realloc (input, message, sizeof (char *) * ((input_len) + 1));
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	(input)[(input_len)] = NULL;

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrArrayToStr method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_array_to_str (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	output_value = output;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &output_value)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

static DBusHandlerResult
com_netsplit_Nih_Test_StrToStrArray_marshal (NihDBusObject  *object,
                                             NihDBusMessage *message)
{
	DBusMessageIter   iter;
	DBusMessage      *reply = NULL;
	char             *input;
	char             *input_value;
	char            **output;
	DBusMessageIter   output_iter;
	size_t            output_len;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_STRING) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToStrArray method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &input_value);

	input = nih_strdup (message, input_value);
	if (! input) {
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to StrToStrArray method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_str_to_str_array (object->data, message, input, &output) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);

	if (! dbus_message_iter_open_container (&iter, DBUS_TYPE_ARRAY, "s", &output_iter)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

	output_len = 0;
	for (char **output_p = output; output_p && *output_p; output_p++) {
		char *output_elem;
		char *output_elem_value;

		output_elem = *output_p;

		output_elem_value = output_elem;
		if (! dbus_message_iter_append_basic (&output_iter, DBUS_TYPE_STRING, &output_elem_value)) {
			dbus_message_unref (reply);
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		(output_len)++;
	}

	if (! dbus_message_iter_close_container (&iter, &output_iter)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	}

send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

int
my_test_signal (DBusConnection *connection,
                const char     *origin_path,
                const char     *text,
                int32_t         flags)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	const char      *text_value;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "TestSignal");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	text_value = text;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &text_value)) {
		dbus_message_unref (message);
		return -1;

	}

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &flags)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_byte (DBusConnection *connection,
              const char     *origin_path,
              uint8_t         data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitByte");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_BYTE, &data)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_boolean (DBusConnection *connection,
                 const char     *origin_path,
                 int             data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitBoolean");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_BOOLEAN, &data)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_int16 (DBusConnection *connection,
               const char     *origin_path,
               int16_t         data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitInt16");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT16, &data)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_uint16 (DBusConnection *connection,
                const char     *origin_path,
                uint16_t        data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitUInt16");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_UINT16, &data)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_int32 (DBusConnection *connection,
               const char     *origin_path,
               int32_t         data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitInt32");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT32, &data)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_uint32 (DBusConnection *connection,
                const char     *origin_path,
                uint32_t        data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitUInt32");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_UINT32, &data)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_int64 (DBusConnection *connection,
               const char     *origin_path,
               int64_t         data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitInt64");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_INT64, &data)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_uint64 (DBusConnection *connection,
                const char     *origin_path,
                uint64_t        data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitUInt64");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_UINT64, &data)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_double (DBusConnection *connection,
                const char     *origin_path,
                double          data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitDouble");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_DOUBLE, &data)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_string (DBusConnection *connection,
                const char     *origin_path,
                const char     *data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	const char      *data_value;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitString");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	data_value = data;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_STRING, &data_value)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_object_path (DBusConnection *connection,
                     const char     *origin_path,
                     const char     *data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	const char      *data_value;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitObjectPath");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	data_value = data;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_OBJECT_PATH, &data_value)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_signature (DBusConnection *connection,
                   const char     *origin_path,
                   const char     *data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	const char      *data_value;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitSignature");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	data_value = data;
	if (! dbus_message_iter_append_basic (&iter, DBUS_TYPE_SIGNATURE, &data_value)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_int32_array (DBusConnection *connection,
                     const char     *origin_path,
                     const int32_t  *data,
                     size_t          data_len)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	DBusMessageIter  data_iter;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitInt32Array");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_open_container (&iter, DBUS_TYPE_ARRAY, "i", &data_iter)) {
		dbus_message_unref (message);
		return -1;

	}

	for (const int32_t *data_p = data; data_p < data + data_len; data_p++) {
		int32_t data_elem;

		data_elem = *data_p;

		if (! dbus_message_iter_append_basic (&data_iter, DBUS_TYPE_INT32, &data_elem)) {
			dbus_message_unref (message);
			return -1;

		}
	}

	if (! dbus_message_iter_close_container (&iter, &data_iter)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

int
my_emit_str_array (DBusConnection *connection,
                   const char     *origin_path,
                   char * const   *data)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	DBusMessageIter  data_iter;
	size_t           data_len;

	nih_assert (connection != NULL);
	nih_assert (origin_path != NULL);

	message = dbus_message_new_signal (origin_path, "com.netsplit.Nih.Test", "EmitStrArray");
	if (! message)
		return -1;

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);

	if (! dbus_message_iter_open_container (&iter, DBUS_TYPE_ARRAY, "s", &data_iter)) {
		dbus_message_unref (message);
		return -1;

	}

	data_len = 0;
	for (char * const *data_p = data; data_p && *data_p; data_p++) {
		char *data_elem;
		char *data_elem_value;

		data_elem = *data_p;

		data_elem_value = data_elem;
		if (! dbus_message_iter_append_basic (&data_iter, DBUS_TYPE_STRING, &data_elem_value)) {
			dbus_message_unref (message);
			return -1;

		}

		(data_len)++;
	}

	if (! dbus_message_iter_close_container (&iter, &data_iter)) {
		dbus_message_unref (message);
		return -1;

	}

	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (connection, message, NULL)) {
		dbus_message_unref (message);
		return -1;
	}

	dbus_message_unref (message);

	return 0;
}

static DBusHandlerResult
com_netsplit_Nih_Glue_EmitSignal_marshal (NihDBusObject  *object,
                                          NihDBusMessage *message)
{
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	int32_t          signum;

	nih_assert (object != NULL);
	nih_assert (message != NULL);

	/* Iterate the arguments to the message and marshal into arguments
	 * for our own function call.
	 */
	dbus_message_iter_init (message->message, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INT32) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to EmitSignal method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	dbus_message_iter_get_basic (&iter, &signum);

	dbus_message_iter_next (&iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		reply = dbus_message_new_error (message->message, DBUS_ERROR_INVALID_ARGS,
						_("Invalid arguments to EmitSignal method"));
		if (! reply) {
			return DBUS_HANDLER_RESULT_NEED_MEMORY;

		}

		goto send;

	}

	/* Call the handler function. */
	if (my_emit_signal (object->data, message, signum) < 0) {
		NihError *err;

		err = nih_error_get ();
		if (err->number == ENOMEM) {
			nih_free (err);

			return DBUS_HANDLER_RESULT_NEED_MEMORY;
		} else if (err->number == NIH_DBUS_ERROR) {
			NihDBusError *dbus_err = (NihDBusError *)err;

			reply = dbus_message_new_error (message->message,
							dbus_err->name,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		} else {
			reply = dbus_message_new_error (message->message,
							DBUS_ERROR_FAILED,
							err->message);
			nih_free (err);

			if (! reply)
				return DBUS_HANDLER_RESULT_NEED_MEMORY;

			goto send;
		}
	}

	/* If the sender doesn't care about a reply, don't bother wasting
	 * effort constructing and sending one.
	 */
	if (dbus_message_get_no_reply (message->message))
		return DBUS_HANDLER_RESULT_HANDLED;

	/* Construct the reply message */
	reply = dbus_message_new_method_return (message->message);
	if (! reply)
		return DBUS_HANDLER_RESULT_NEED_MEMORY;

	dbus_message_iter_init_append (reply, &iter);


send:
	/* Send the reply, appending it to the outgoing queue. */
	if (! dbus_connection_send (message->conn, reply, NULL)) {
		dbus_message_unref (reply);
		return DBUS_HANDLER_RESULT_NEED_MEMORY;
	}

	dbus_message_unref (reply);

	return DBUS_HANDLER_RESULT_HANDLED;
}

