/* upstart
 *
 * com.ubuntu.Upstart.Instance.c - Auto-generated d-bus bindings
 *
 * Copyright © 2008 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifdef HAVE_CONFIG_H
# include <config.h>
#endif /* HAVE_CONFIG_H */


#include <dbus/dbus.h>

#include <errno.h>
#include <limits.h>

#include <nih/macros.h>
#include <nih/alloc.h>
#include <nih/string.h>
#include <nih/logging.h>
#include <nih/error.h>
#include <nih/errors.h>
#include <nih/dbus.h>

#include "com.ubuntu.Upstart.Instance.h"


int
job_start (NihDBusProxy *proxy)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	DBusError        error;

	nih_assert (proxy != NULL);

	message = dbus_message_new_method_call (proxy->name, proxy->path, "com.ubuntu.Upstart.Instance", "Start");
	if (! message)
		nih_return_no_memory_error (-1);

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);


	dbus_error_init (&error);

	/* Send the reply, appending it to the outgoing queue and blocking. */
	reply = dbus_connection_send_with_reply_and_block (proxy->conn, message, -1, &error);
	if (! reply) {
		dbus_message_unref (message);

		if (dbus_error_has_name (&error, DBUS_ERROR_NO_MEMORY)) {
			dbus_error_free (&error);
			nih_return_no_memory_error (-1);
		} else {
			nih_dbus_error_raise (error.name, error.message);
			dbus_error_free (&error);
			return -1;
		}
	}

	dbus_message_unref (message);

	/* Iterate the arguments to the reply and marshal into output
	 * arguments from our own function call.
	 */
	dbus_message_iter_init (reply, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		dbus_message_unref (reply);
		nih_return_error (-1, NIH_DBUS_INVALID_ARGS, NIH_DBUS_INVALID_ARGS_STR);

	}

	dbus_message_unref (reply);

	return 0;
}

int
job_stop (NihDBusProxy *proxy)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	DBusError        error;

	nih_assert (proxy != NULL);

	message = dbus_message_new_method_call (proxy->name, proxy->path, "com.ubuntu.Upstart.Instance", "Stop");
	if (! message)
		nih_return_no_memory_error (-1);

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);


	dbus_error_init (&error);

	/* Send the reply, appending it to the outgoing queue and blocking. */
	reply = dbus_connection_send_with_reply_and_block (proxy->conn, message, -1, &error);
	if (! reply) {
		dbus_message_unref (message);

		if (dbus_error_has_name (&error, DBUS_ERROR_NO_MEMORY)) {
			dbus_error_free (&error);
			nih_return_no_memory_error (-1);
		} else {
			nih_dbus_error_raise (error.name, error.message);
			dbus_error_free (&error);
			return -1;
		}
	}

	dbus_message_unref (message);

	/* Iterate the arguments to the reply and marshal into output
	 * arguments from our own function call.
	 */
	dbus_message_iter_init (reply, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		dbus_message_unref (reply);
		nih_return_error (-1, NIH_DBUS_INVALID_ARGS, NIH_DBUS_INVALID_ARGS_STR);

	}

	dbus_message_unref (reply);

	return 0;
}

int
job_restart (NihDBusProxy *proxy)
{
	DBusMessage     *message;
	DBusMessageIter  iter;
	DBusMessage     *reply = NULL;
	DBusError        error;

	nih_assert (proxy != NULL);

	message = dbus_message_new_method_call (proxy->name, proxy->path, "com.ubuntu.Upstart.Instance", "Restart");
	if (! message)
		nih_return_no_memory_error (-1);

	/* Iterate the arguments to the function and dispatch into
	 * message arguments.
	 */
	dbus_message_iter_init_append (message, &iter);


	dbus_error_init (&error);

	/* Send the reply, appending it to the outgoing queue and blocking. */
	reply = dbus_connection_send_with_reply_and_block (proxy->conn, message, -1, &error);
	if (! reply) {
		dbus_message_unref (message);

		if (dbus_error_has_name (&error, DBUS_ERROR_NO_MEMORY)) {
			dbus_error_free (&error);
			nih_return_no_memory_error (-1);
		} else {
			nih_dbus_error_raise (error.name, error.message);
			dbus_error_free (&error);
			return -1;
		}
	}

	dbus_message_unref (message);

	/* Iterate the arguments to the reply and marshal into output
	 * arguments from our own function call.
	 */
	dbus_message_iter_init (reply, &iter);

	if (dbus_message_iter_get_arg_type (&iter) != DBUS_TYPE_INVALID) {
		dbus_message_unref (reply);
		nih_return_error (-1, NIH_DBUS_INVALID_ARGS, NIH_DBUS_INVALID_ARGS_STR);

	}

	dbus_message_unref (reply);

	return 0;
}

