/* upstart
 *
 * Copyright © 2008 Canonical Ltd.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA
 */

#ifndef DBUS__COM_UBUNTU_UPSTART_JOB_H
#define DBUS__COM_UBUNTU_UPSTART_JOB_H

#include <dbus/dbus.h>

#include <nih/macros.h>
#include <nih/dbus.h>


NIH_BEGIN_EXTERN

int job_class_get_instance         (NihDBusProxy *proxy, char * const *env, char **instance)
	__attribute__ ((warn_unused_result));
int job_class_get_instance_by_name (NihDBusProxy *proxy, const char *name, char **instance)
	__attribute__ ((warn_unused_result));
int job_class_get_all_instances    (NihDBusProxy *proxy, char ***instances)
	__attribute__ ((warn_unused_result));
int job_class_start                (NihDBusProxy *proxy, char * const *env, char **instance)
	__attribute__ ((warn_unused_result));
int job_class_stop                 (NihDBusProxy *proxy, char * const *env)
	__attribute__ ((warn_unused_result));
int job_class_restart              (NihDBusProxy *proxy, char * const *env, char **instance)
	__attribute__ ((warn_unused_result));

NIH_END_EXTERN

#endif /* DBUS__COM_UBUNTU_UPSTART_JOB_H */

